#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
RF24 radio(8, 10); // CE, CSN
const byte address[6] = "00001";
char receivedData[32] = "";
int  xAxis, yAxis;

#define LeftMotorEnA 2  
#define in1 3
#define in2 4
#define RightMotorEnB 7   
#define in3 5
#define in4 6
//int xAxis = 275, yAxis = 80;
int LeftMotorSpeedA = 0;
int RightMotorSpeedB = 0;

void setup() {
  Serial.begin(9600);
  radio.begin();
  radio.openReadingPipe(0, address);
  radio.setPALevel(RF24_PA_MIN);
  radio.startListening();
  pinMode(LeftMotorEnA, OUTPUT);
  pinMode(RightMotorEnB, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
}
void loop() {
  if (radio.available()) {   // If the NRF240L01 module received data
    radio.read(&receivedData, sizeof(receivedData)); // Read the data and put it into character array
    xAxis = atoi(&receivedData[0]); // Convert the data from the character array (received X value) into integer
    Serial.print(xAxis);
    delay(20);
    radio.read(&receivedData, sizeof(receivedData));
    yAxis = atoi(&receivedData[0]);
    Serial.print("\t");
    Serial.println(yAxis);
    delay(20);
   }
  analogWrite(LeftMotorEnA, LeftMotorSpeedA); // Send PWM signal to motor A
  analogWrite(RightMotorEnB, RightMotorSpeedB); // Send PWM signal to motor B
   // x-axis used for forward and backward control
  if (xAxis > 100) {
    LeftMotorSpeedA = map(xAxis, 0, 550, 0, 255);
    RightMotorSpeedB = map(xAxis, 0, 550, 0, 255);
    // Set Motor A/left forward
    digitalWrite(in1, HIGH);
    digitalWrite(in2, LOW);
    digitalWrite(in3, LOW);
    digitalWrite(in4, HIGH);
    }
  else if (xAxis < 50) {
    LeftMotorSpeedA = map(xAxis, 550, 0, 0, 255);
    RightMotorSpeedB = map(xAxis, 550, 0, 0, 255);
    digitalWrite(in1, LOW);
    digitalWrite(in2, HIGH);
    digitalWrite(in3, HIGH);
    digitalWrite(in4, LOW);
 }
  // If joystick stays in middle the motors are not moving
  else {
    LeftMotorSpeedA = 0;
    RightMotorSpeedB = 0;
  } 
  // Y-axis used for left and right control  // right turn
   if (yAxis > 150) {
    int yMapped = map(yAxis, 250, 0, 255, 0);
    LeftMotorSpeedA = LeftMotorSpeedA + yMapped; 
    RightMotorSpeedB = RightMotorSpeedB + yMapped;
    digitalWrite(in1, LOW);
    digitalWrite(in2, LOW);
    // Set Motor B/right forward
    digitalWrite(in3, LOW);
    digitalWrite(in4, HIGH);
   } 
  // Y-axis used for left
  if (yAxis < 50) {
    int yMapped = map(yAxis, 250, 0, 0, 255);
    LeftMotorSpeedA = LeftMotorSpeedA + yMapped;
    RightMotorSpeedB = RightMotorSpeedB + yMapped;
    digitalWrite(in1, HIGH);
    digitalWrite(in2, LOW);
    digitalWrite(in3, LOW);
    digitalWrite(in4, LOW);
   }
  }
